import static libtest.Lanceur.*;
import static libtest.OutilTest.*;


/**
 * Classe de test pour Labyrinthe
 *
 */
public class TestLabyrinthe {
	
	/**
	 * constructeur du labyrinthe
	 */
	public void test_1_constructeurNormal()
	{
		Labyrinthe l=new Labyrinthe(5);
		
		//test case vides
		for (int i=0;i<5;i++)
			for (int j=0;j<5;j++)
			{
				if ((i==0)||(i==4)||(j==0)||(j==4))
				{	
					//c'est l'arene
					assertEquals(false,l.etreVide(i, j),"la case ("+i+","+j+") fait partie de l'enceinte");
				}
				else
				{
					//interieur de l'enceinte doit etre vide
					assertEquals(true,l.etreVide(i, j),"la case ("+i+","+j+") fait partie de l'enceinte");
				}
				
			}
		
	}
	
	/**
	 * constructeur du labyrinthe taille nulle
	 */
	public void test_2_constructeurNulle()
	{
		Labyrinthe l=new Labyrinthe(0);
		l=new Labyrinthe(-1);		
	}
	
	/**
	 * methode remplir
	 */
	public void test_3_remplir()
	{
		Labyrinthe l=new Labyrinthe(6);
		l.remplir();
		for (int i=0;i<6;i++)
			for (int j=0;j<6;j++)
			{
				assertEquals(false,l.etreVide(i, j),"la case "+i+","+j+" devrait etre pleine");
			}
				
	}
	
	/**
	 * methode creuser normal
	 */
	public void test_4_creuser()
	{
		Labyrinthe l=new Labyrinthe(6);
		l.remplir();
		l.creuser(1, 1, 3, 3);
				
		for (int i=0;i<6;i++)
			for (int j=0;j<6;j++)
			{
				//si on est sur l'endroit creuser
				if ((i>=1)&&(i<=3)&&(j>=1)&&(j<=3))
					assertEquals(true,l.etreVide(i, j),"la case "+i+","+j+" devrait etre vide");
				else
					//sinon on est dans un mur
					assertEquals(false,l.etreVide(i, j),"la case "+i+","+j+" devrait etre vide");
			}
				
	}
	
	/**
	 * methode creuser inverse ordre
	 */
	public void test_5_creuserInverse()
	{
		Labyrinthe l=new Labyrinthe(6);
		l.remplir();
		l.creuser(1, 3, 3, 1);
				
		for (int i=0;i<6;i++)
			for (int j=0;j<6;j++)
			{
				//si on est sur l'endroit creuser
				if ((i>=1)&&(i<=3)&&(j>=1)&&(j<=3))
					assertEquals(true,l.etreVide(i, j),"la case "+i+","+j+" devrait etre vide");
				else
					//sinon on est dans un mur
					assertEquals(false,l.etreVide(i, j),"la case "+i+","+j+" devrait etre vide");
			}
				
	}
	
	/**
	 * methode creuser couloir
	 */
	public void test_6_creuserCouloir()
	{
		Labyrinthe l=new Labyrinthe(6);
		l.remplir();
		l.creuser(1, 1, 3, 1);
				
		assertEquals(true, l.etreVide(1,1),"la case (1,1) devrait etre vide");
		assertEquals(true, l.etreVide(2,1),"la case (2,1) devrait etre vide");
		assertEquals(true, l.etreVide(3,1),"la case (3,1) devrait etre vide");
				
	}
	
	/**
	 * methode creuser sort du labyrinthe
	 */
	public void test_7_creuserTropGrand()
	{
		Labyrinthe l=new Labyrinthe(6);
		l.remplir();
		l.creuser(1, 1, 7, 1);
				
		assertEquals(true, l.etreVide(1,1),"la case (1,1) devrait etre vide");
		assertEquals(true, l.etreVide(2,1),"la case (2,1) devrait etre vide");
		assertEquals(true, l.etreVide(3,1),"la case (3,1) devrait etre vide");
		assertEquals(true, l.etreVide(5,1),"la case (3,1) devrait etre vide");
		
				
	}
	
	/**
	 * methode creuser entoure le labyrinthe
	 */
	public void test_8_creuserToutLabyrinthe()
	{
		Labyrinthe l=new Labyrinthe(6);
		l.remplir();
		l.creuser(-1, -1, 7, 7);
				
		assertEquals(true, l.etreVide(1,1),"la case (1,1) devrait etre vide");
		assertEquals(true, l.etreVide(2,1),"la case (2,1) devrait etre vide");
		assertEquals(true, l.etreVide(3,1),"la case (3,1) devrait etre vide");
		assertEquals(true, l.etreVide(5,1),"la case (3,1) devrait etre vide");
		
				
	}
	
	/**
	 * methode creuser en dehors du labyrinthe
	 */
	public void test_9_creuserDehorsLabyrinthe()
	{
		Labyrinthe l=new Labyrinthe(6);
		l.remplir();
		l.creuser(7, 7, 10, 10);
				
		assertEquals(false, l.etreVide(1,1),"la case (1,1) devrait etre vide");
		assertEquals(false, l.etreVide(2,1),"la case (2,1) devrait etre vide");
		assertEquals(false, l.etreVide(3,1),"la case (3,1) devrait etre vide");
		assertEquals(false, l.etreVide(5,1),"la case (3,1) devrait etre vide");		
	}
	
	/**
	 * methode etrevide quand on sort du labyrinthe
	 */
	public void test_10_etreVide()
	{
		Labyrinthe l=new Labyrinthe(6);
		l.remplir();
		
		assertEquals(false,l.etreVide(7,1),"devrait etre faux en dehors du labyrinthe");
		assertEquals(false,l.etreVide(5,9),"devrait etre faux en dehors du labyrinthe");
		assertEquals(false,l.etreVide(5,-1),"devrait etre faux en dehors du labyrinthe");
		assertEquals(false,l.etreVide(-1,4),"devrait etre faux en dehors du labyrinthe");
				
	}
	
	
	
	
	/**
	 * lancement des tests
	 * @param args
	 */
	public static void main(String args[])
	{
		lancer(new TestLabyrinthe(),args);
	}
	
}
